"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UtilSnippet = void 0;
const chalk_1 = __importDefault(require("chalk"));
const fs_1 = __importDefault(require("fs"));
const enums_1 = require("../../enums");
const string_1 = require("../string");
class UtilSnippet {
    string;
    constructor() {
        this.string = new string_1.UtilString();
    }
    format({ pathToSnippet, name }) {
        const unformattedSnippet = JSON.stringify(fs_1.default.readFileSync(pathToSnippet, 'utf-8'));
        const formattedSnippet = unformattedSnippet
            .replaceAll(enums_1.enumSnippetName.camelCase, `${this.string.toCamelCase(name)}`)
            .replaceAll(enums_1.enumSnippetName.pascalCase, `${this.string.toPascalCase(name)}`)
            .replaceAll(enums_1.enumSnippetName.lowerSnakeCase, `${this.string.toLowerSnakeCase(name)}`)
            .replaceAll(enums_1.enumSnippetName.upperSnakeCase, `${this.string.toUpperSnakeCase(name)}`)
            .replaceAll(enums_1.enumSnippetName.lowerKebabCase, `${this.string.toLowerKebabCase(name)}`)
            .replaceAll(enums_1.enumSnippetName.upperKebabCase, `${this.string.toUpperKebabCase(name)}`);
        return JSON.parse(formattedSnippet);
    }
    create(options) {
        const mkdir = options.isFlat ? options.pathFlatSnippetFile : options.pathSnippetFile;
        const writeFile = options.isFlat ? options.pathFlatWriteSnippetFile : options.pathWriteSnippetFile;
        fs_1.default.mkdirSync(mkdir, { recursive: true });
        fs_1.default.writeFileSync(writeFile, options.formattedSnippet);
        // eslint-disable-next-line no-console
        console.log(`${chalk_1.default.green(`√`)} ${chalk_1.default.gray(`${options.snippetFileName}`)}`);
    }
}
exports.UtilSnippet = UtilSnippet;
